#ifdef SYSTEMC
/*
 * $Id$
 *
 * [ Description ]
 * 
 */

#include "Behavioural/Generic/Select/Priority_Fixed/include/Priority_Fixed.h"

namespace morpheo                    {
namespace behavioural {
namespace generic {
namespace select {
namespace priority_fixed {


  void Priority_Fixed::deallocation (void)
  {
    log_printf(FUNC,Priority_Fixed,"deallocation","Begin");

//#if defined(STATISTICS) or defined(VHDL_TESTBENCH)
    delete in_CLOCK;
//#endif

    for (uint32_t i=0; i<_param._nb_entity; i++)
      {
	delete  in_VAL [i];
	if (_param._encoding_one_hot)
	delete out_ACK [i];
      }

    delete  in_VAL;
    if (_param._encoding_one_hot)
    delete out_ACK;
    if (_param._encoding_compact)
      {
    delete out_ENTITY;
    delete out_ENTITY_ACK;
      }
    // ~~~~~[ Component ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~    

    log_printf(FUNC,Priority_Fixed,"deallocation","End");
  };

}; // end namespace priority_fixed
}; // end namespace select
}; // end namespace generic

}; // end namespace behavioural
}; // end namespace morpheo              
#endif
